<Cabbage>
form caption("Untitled") size(640, 480), colour(58, 110, 182), pluginid("def1")

groupbox bounds(16, 14, 249, 131) text("oscillator 0")
rslider bounds(30, 44, 36, 42) range(0, 1, 0, 1, 0.001)       channel("osc0_T1L")        text("T1L")  value(1)
rslider bounds(30, 84, 36, 42) range(0, 1, 0, 1, 0.001)       channel("osc0_T1R")        text("T1R")  value(0.001)
rslider bounds(60, 44, 36, 42) range(0, 1, 0, 1, 0.001)       channel("osc0_T2L")        text("T2L")  value(0.7)
rslider bounds(60, 84, 36, 42) range(0, 1, 0, 1, 0.001)       channel("osc0_T2R")        text("T2R")  value(0.3)
rslider bounds(90, 44, 36, 42) range(0, 1, 0, 1, 0.001)       channel("osc0_T3L")        text("T3L")  value(0.3)
rslider bounds(90, 84, 36, 42) range(0, 1, 0, 1, 0.001)       channel("osc0_T3R")        text("T3R")  value(1)
rslider bounds(120, 44, 36, 42) range(0, 1, 0, 1, 0.001)      channel("osc0_T4L")        text("T4L")  value(0.3)
rslider bounds(120, 84, 36, 42) range(0, 1, 0, 1, 0.001)      channel("osc0_T4R")        text("T4R")  value(0)
rslider bounds(150, 44, 36, 42) range(0, 60, 0, 1, 1)         channel("osc0_mod_coarse") text("MODC") value(1)
rslider bounds(150, 84, 36, 42) range(0, 10, 0, 1, 0.001)     channel("osc0_mod_fine")   text("MODF") value(1)
rslider bounds(180, 44, 36, 42) range(0.125, 32, 0, 1, 0.125) channel("osc0_freq")       text("FREQ") value(1)
rslider bounds(180, 84, 36, 42) range(0, 0.5, 0, 1, 0.001)    channel("osc0_feed")       text("FEED") value(0)
vslider bounds(222, 44, 27, 89) range(0, 1, 0, 1, 0.001)      channel("osc0_volume")                  value(1)

groupbox bounds(300, 14, 249, 131) text("oscillator 1")
rslider bounds(330, 44, 36, 42) range(0, 1, 0, 1, 0.001)      channel("osc1_T1L")        text("T1L")  value(1)
rslider bounds(330, 84, 36, 42) range(0, 1, 0, 1, 0.001)      channel("osc1_T1R")        text("T1R")  value(0.001)
rslider bounds(360, 44, 36, 42) range(0, 1, 0, 1, 0.001)      channel("osc1_T2L")        text("T2L")  value(0.7)
rslider bounds(360, 84, 36, 42) range(0, 1, 0, 1, 0.001)      channel("osc1_T2R")        text("T2R")  value(0.3)
rslider bounds(390, 44, 36, 42) range(0, 1, 0, 1, 0.001)      channel("osc1_T3L")        text("T3L")  value(0.3)
rslider bounds(390, 84, 36, 42) range(0, 1, 0, 1, 0.001)      channel("osc1_T3R")        text("T3R")  value(1)
rslider bounds(420, 44, 36, 42) range(0, 1, 0, 1, 0.001)      channel("osc1_T4L")        text("T4L")  value(0.3)
rslider bounds(420, 84, 36, 42) range(0, 1, 0, 1, 0.001)      channel("osc1_T4R")        text("T4R")  value(0)
rslider bounds(450, 44, 36, 42) range(0, 60, 0, 1, 1)         channel("osc1_mod_coarse") text("MODC") value(1)
rslider bounds(450, 84, 36, 42) range(0, 10, 0, 1, 0.001)     channel("osc1_mod_fine")   text("MODF") value(1)
rslider bounds(480, 44, 36, 42) range(0.125, 32, 0, 1, 0.125) channel("osc1_freq")       text("FREQ") value(1)
rslider bounds(480, 84, 36, 42) range(0, 0.5, 0, 1, 0.001)    channel("osc1_feed")       text("FEED") value(0)
vslider bounds(522, 44, 27, 89) range(0, 1, 0, 1, 0.001)      channel("osc1_volume")                  value(1)
</Cabbage>

<CsoundSynthesizer>
  <CsOptions>
    -n -d -+rtmidi=NULL -M0 -m0d --midi-key-cps=4 --midi-velocity-amp=5
  </CsOptions>

  <CsInstruments>
    ; Initialize the global variables. 
    ksmps = 32
    nchnls = 2
    0dbfs = 1

    ; Evaluate the GEN10 routine and insert the contents into a table
    ; https://csound.com/docs/manual/GEN10.html
    gisine ftgen 1, 0, 16384, 10, 1

    ;instrument will be triggered by keyboard widget
    instr 1
      kBaseFrequency = p4
      kBaseAmplitude = p5

      iOsc0_T1L chnget "osc0_T1L"
      iOsc0_T1R chnget "osc0_T1R"
      iOsc0_T2L chnget "osc0_T2L"
      iOsc0_T2R chnget "osc0_T2R"
      iOsc0_T3L chnget "osc0_T3L"
      iOsc0_T3R chnget "osc0_T3R"
      iOsc0_T4L chnget "osc0_T4L"
      iOsc0_T4R chnget "osc0_T4R"
      kOsc0_mod_c chnget "osc0_mod_coarse"
      kOsc0_mod_f chnget "osc0_mod_fine"
      kOsc0_feed  chnget "osc0_feed"
      kOsc0_volume chnget "osc0_volume"
      kOsc0_freq_ctrl chnget "osc0_freq"
      kOsc0_mod init 0
      kOsc0_mod = kOsc0_mod_c + kOsc0_mod_f
      kOsc0_env linsegr iOsc0_T1L, iOsc0_T1R, iOsc0_T2L, iOsc0_T2R, iOsc0_T3L, iOsc0_T3R, iOsc0_T4L, iOsc0_T4R, 0
      kOsc0_freq init 0
      kOsc0_freq = kBaseFrequency * kOsc0_freq_ctrl

      iOsc1_T1L chnget "osc1_T1L"
      iOsc1_T1R chnget "osc1_T1R"
      iOsc1_T2L chnget "osc1_T2L"
      iOsc1_T2R chnget "osc1_T2R"
      iOsc1_T3L chnget "osc1_T3L"
      iOsc1_T3R chnget "osc1_T3R"
      iOsc1_T4L chnget "osc1_T4L"
      iOsc1_T4R chnget "osc1_T4R"
      kOsc1_mod_c chnget "osc1_mod_coarse"
      kOsc1_mod_f chnget "osc1_mod_fine"
      kOsc1_feed chnget "osc1_feed"
      kOsc1_volume chnget "osc1_volume"
      kOsc1_freq_ctrl chnget "osc1_freq"
      kOsc1_mod init 0
      kOsc1_mod = kOsc1_mod_c + kOsc1_mod_f
      kOsc1_env linsegr iOsc1_T1L, iOsc1_T1R, iOsc1_T2L, iOsc1_T2R, iOsc1_T3L, iOsc1_T3R, iOsc1_T4L, iOsc1_T4R, 0
      kOsc1_freq init 0
      kOsc1_freq = kBaseFrequency * kOsc1_freq_ctrl
    
      aOsc0_phasor phasor kOsc0_freq
      aOsc0_value init 0
      aOsc0_mod = kOsc0_mod + (kOsc0_feed * aOsc0_value)
      aOsc0_value tablei (aOsc0_phasor + aOsc0_mod), 1, 1, 0, 1
      aOsc0_out = aOsc0_value * kOsc0_env * kOsc0_volume

      aOsc1_phasor phasor kOsc1_freq
      aOsc1_value init 0
      aOsc1_mod = aOsc0_out * kOsc1_mod + (kOsc1_feed * aOsc1_value)
      aOsc1_value tablei (aOsc1_phasor + aOsc1_mod), 1, 1, 0, 1
      aOsc1_out = aOsc1_value * kOsc1_env * kOsc1_volume

      outs aOsc1_out,aOsc1_out
    endin
  </CsInstruments>

  <CsScore>
    ;causes Csound to run for about 7000 years...
    f0 z
  </CsScore>
</CsoundSynthesizer>
